﻿using System;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.IO.Compression;
using System.Text.RegularExpressions;

namespace WindowsFormsApplication1
{
    public class Document
    {
        private string wFolder = @"";
        private Recorder rec = null;
        private int currentWork = -1;
        private DataTable db = null;
        private readonly HashSet<string> usedUtts = new HashSet<string>();
        private int index = 1;
        private Iserv frm;
        private static Main fmain;
        private const int R_FILE = 0;
        private const int R_TIME = 1;
        private const int R_BAD = 2;
        private const int R_UTT = 3;
        private const int R_COM = 4;
        private const int R_EXT = 5;
        private const int R_PLAY = 6;
        private const int R_CLEAR = 7;


        private bool allDone = false;
        private int counter;

        public Document(Main m)
        {
            fmain = m;
            NewDoc();
        }
        public int GetWorkSize()
        {
            return db.Rows.Count;
        }
        public int GetWorkDone()
        {
            int counter = 0;
            for (int i = 0; i < db.Rows.Count; i++)
            {
                if (!string.Equals((string)db.Rows[i][R_TIME], "", StringComparison.Ordinal))
                {
                    counter++;
                }
            }
            return counter;
        }
        public int GetNextWork()
        {

            for (int i = 0; i < db.Rows.Count; i++)
            {
                if (string.Equals((string)db.Rows[i][R_TIME], "", StringComparison.Ordinal))
                {
                    return i;
                }
            }
            return -1;
        }

        public bool IsGCinit()
        {
            if (frm == null)
            {
                return false;
            }
            else
            {
                return true;
            }
        }

        public void GcInit()
        {
            if (rec != null)
            {
                rec.Close();
                rec = null;

            }
            rec = new Recorder();
            frm = new Iserv(this);
            allDone = false;


            frm.Show();

        }
        public void GcClose()
        {
            Console.WriteLine("gcClose");

            frm.Close();
            frm = null;


            fmain.UpdateStats();
        }

        public void GcCloseF()
        {
            Console.WriteLine("gcCloseF");

            if (rec != null)
            {
                rec.Close();
                rec = null;
            }

            frm = null;
            fmain.UpdateStats();
        }

        internal void LoadWork()
        {
            using (StreamReader sr = new StreamReader(wFolder + "0index.kj2"))
            {
                Load(sr);
            }
        }

        internal void SaveWork()
        {
            if (string.Equals(wFolder, "", StringComparison.Ordinal))
            {
                return;
            }
            using (FileStream fs = new FileStream(wFolder + "0index.kj2", FileMode.Create))
            {
                Save(fs);
            }
        }

        public string GetFilenameRow(DataRow row)
        {
            return wFolder + row[R_FILE];
        }
        public void GcNext()
        {
            Console.WriteLine("gcNext");
            if (rec == null)
            {
                return;
            }
            if (rec.IsRecording())
            {
                string a = rec.StopRec();
                db.Columns[R_TIME].ReadOnly = false;
                db.Rows[currentWork][R_TIME] = a;
                db.Columns[R_TIME].ReadOnly = true;

                db.Columns[R_PLAY].ReadOnly = false;
                db.Rows[currentWork][R_PLAY] = "▶️";
                db.Columns[R_PLAY].ReadOnly = true;

                db.Columns[R_CLEAR].ReadOnly = false;
                db.Rows[currentWork][R_CLEAR] = "❌";
                db.Columns[R_CLEAR].ReadOnly = true;


            }
            currentWork = GetNextWork();
            if (!allDone)
            {
                if (currentWork > -1)
                {
                    frm.SetUtt((string)db.Rows[currentWork][R_UTT]);
                    fmain.SetUtt((string)db.Rows[currentWork][R_UTT]);
                    rec.StartRec(wFolder + db.Rows[currentWork][R_FILE]);
                    AddCount();
                    fmain.UpdateStats();
                }
                else
                {
                    allDone = true;
                    frm.SetUtt("Valmis! Sule aken.");
                    fmain.SetUtt("Valmis! Sule aken.");
                    fmain.UpdateStats();
                }
            }
            else
            {

                GcClose();
            }

        }
        public void GcPause()
        {
            if (rec == null)
            {
                return;
            }
            if (rec.IsRecording())
            {
                rec.StopRec();
                frm.SetUtt("Pausis!");
                fmain.SetUtt("Pausis!");
            }
        }
        public void NewDoc()
        {

            db = new DataTable();
            usedUtts.Clear();
            db.Columns.Add("Fail", typeof(string));
            db.Columns[R_FILE].ReadOnly = true;

            db.Columns.Add("Aeg", typeof(string));
            db.Columns[R_TIME].ReadOnly = true;

            db.Columns.Add("Halb", typeof(string));
            db.Columns[R_BAD].ReadOnly = true;

            db.Columns.Add("Sisu", typeof(string));
            db.Columns[R_UTT].ReadOnly = true;

            db.Columns.Add("Kommentaar", typeof(string));

            db.Columns.Add("EXT", typeof(string));
            db.Columns[R_EXT].ReadOnly = true;

            db.Columns.Add(" ", typeof(string));
            db.Columns[R_PLAY].ReadOnly = true;
            db.Columns[R_PLAY].DefaultValue = ""; //▶️🕪🔊


            db.Columns.Add("  ", typeof(string));
            db.Columns[R_CLEAR].ReadOnly = true;
            db.Columns[R_CLEAR].DefaultValue = "";


            //dGV.DataSource = resultsList;
            //dGV.AutoGenerateColumns = false;


            //dGV.Columns[3].Visible = false; 

            //db.Columns[R_TIME].ReadOnly = false;
            //db.Rows[3][R_TIME] = "00:00:06";
            //db.Columns[R_TIME].ReadOnly = true;

        }

        public DataTable GetDS()
        {
            return db;
        }

        public void SaveZip(string filename, string thename)
        {
            using (ZipArchive archive = ZipFile.Open(filename, ZipArchiveMode.Create))
            {
                foreach (DataRow row in db.Rows)
                {
                    string zfilename = Regex.Replace((string)row[R_FILE], "lause_", thename + "_");
                    if (!string.Equals((string)row[R_TIME], "", StringComparison.Ordinal) & !string.Equals((string)row[R_TIME], "Ära loe", StringComparison.Ordinal))
                    {
                        archive.CreateEntryFromFile(wFolder + row[R_FILE], zfilename);
                        // create text
                        string ztfilename = Regex.Replace(zfilename, "\\.wav", ".txt");
                        ZipArchiveEntry txtEntry = archive.CreateEntry(ztfilename);

                        using (StreamWriter writer = new StreamWriter(txtEntry.Open()))
                        {
                            writer.WriteLine(row[R_UTT] + "");
                        }
                    }

                }
                ZipArchiveEntry tsvEntry = archive.CreateEntry("0index.tsv");
                using (StreamWriter writer = new StreamWriter(tsvEntry.Open()))
                {
                    foreach (DataRow row in db.Rows)
                    {
                        string zfilename = Regex.Replace((string)row[R_FILE], "lause_", thename + "_");
                        if (!string.Equals((string)row[R_TIME], "", StringComparison.Ordinal) & !string.Equals((string)row[R_TIME], "Ära loe", StringComparison.Ordinal))
                        {
                            writer.WriteLine(zfilename + "\t" + row[R_UTT] + ""); //\r\n
                        }
                    }
                }
            }

        }


        public void Save(FileStream file)
        {
            //.Replace("\t", " ")
            StreamWriter writer = new StreamWriter(file);
            //writer.WriteLine("!FOLDER\t" + wFolder + "");
            writer.WriteLine("!INDEX\t" + index + "");
            for (int i = 0; i < db.Rows.Count; i++)
            {

                writer.WriteLine(db.Rows[i][R_FILE] + "\t" + db.Rows[i][R_TIME] + "\t" + db.Rows[i][R_BAD] + "\t" + db.Rows[i][R_UTT] + "\t" + db.Rows[i][R_COM] + "\t" + db.Rows[i][R_EXT] + ""); //\r\n
            }
            writer.Flush();

        }

        public void Load(StreamReader file)
        {
            int counter = 0;
            string line;

            while ((line = file.ReadLine()) != null)
            {
                Match match = Regex.Match(line, @"^!FOLDER\t(.+)$", RegexOptions.IgnoreCase);
                if (match.Success)
                {
                    //wFolder = match.Groups[1].Value;

                    continue;
                }
                match = Regex.Match(line, @"^!INDEX\t(\d+)$", RegexOptions.IgnoreCase);
                if (match.Success)
                {
                    index = int.Parse(match.Groups[1].Value);
                    continue;
                }
                match = Regex.Match(line, @"^(.+)\t(.*)\t(.*)\t(.+)\t(.*)\t(.*)$", RegexOptions.IgnoreCase);
                if (match.Success)
                {
                    db.Rows.Add(match.Groups[1].Value, match.Groups[2].Value, match.Groups[3].Value, match.Groups[4].Value, match.Groups[5].Value, match.Groups[6].Value);
                    usedUtts.Add(match.Groups[4].Value);
                }

                counter++;
            }
            GenerateBtns();
            file.Close();
            Console.WriteLine("There were {0} lines.", counter);
            // Suspend the screen.

        }

        private void GenerateBtns()
        {
            foreach (DataRow row in db.Rows)
            {
                if (!string.Equals((string)row[R_TIME], "", StringComparison.Ordinal) & !string.Equals((string)row[R_TIME], "Ära loe", StringComparison.Ordinal))
                {
                    db.Columns[R_PLAY].ReadOnly = false;
                    row[R_PLAY] = "▶️";
                    db.Columns[R_PLAY].ReadOnly = true;

                    db.Columns[R_CLEAR].ReadOnly = false;
                    row[R_CLEAR] = "❌";
                    db.Columns[R_CLEAR].ReadOnly = true;
                }



            }
        }
        public void AddRowToDB(string utt)
        {
            if (utt != null)
            {
                if (!usedUtts.Contains(utt))
                {
                    utt = utt.Replace("\t", " ");
                    db.Rows.Add("lause_" + index.ToString("D5") + ".wav", "", "", utt, "", "");
                    index++;
                    usedUtts.Add(utt);
                }
            }
        }
        public void LoadTXT(StreamReader file)
        {
            string line;
            while ((line = file.ReadLine()) != null)
            {
                AddRowToDB(line);
            }
            file.Close();
        }

        public void LoadInternalWork(string[] work)
        {
            foreach (string line in work)
            {
                AddRowToDB(line);
            }
        }

        public void LoadDemoset()
        {
            AddRowToDB("test");
            AddRowToDB("auto");
            AddRowToDB("kala");
            AddRowToDB("kirst");
            AddRowToDB("kosmos");
            AddRowToDB("ja");
            AddRowToDB("nägu");
            AddRowToDB("laevuke");
            AddRowToDB("kino");
        }


        public void InitCount()
        {
            counter = 0;
        }

        public void AddCount()
        {
            counter++;
        }

        public int GetCount()
        {
            return counter;
        }

        internal void SetWF(string path)
        {
            wFolder = path;
        }

        internal string GetWF()
        {
            return wFolder;
        }

        internal void SetRowStatus(DataRow row)
        {
            db.Columns[R_BAD].ReadOnly = false;
            if ("halb" == (string)row[R_BAD])
            {
                row[R_BAD] = "";
            }
            else
            {
                row[R_BAD] = "halb";
            }

            db.Columns[R_BAD].ReadOnly = true;
        }

        internal void ClearRowDone(DataRow row)
        {
            db.Columns[R_TIME].ReadOnly = false;
            row[R_TIME] = "";
            db.Columns[R_TIME].ReadOnly = true;

        }
        internal void DoggleRowSkip(DataRow row)
        {

            if (string.Equals((string)row[R_TIME], "", StringComparison.Ordinal))
            {
                db.Columns[R_TIME].ReadOnly = false;
                row[R_TIME] = "Ära loe";
                db.Columns[R_TIME].ReadOnly = true;
            }
            else if (string.Equals((string)row[R_TIME], "Ära loe", StringComparison.Ordinal))
            {
                db.Columns[R_TIME].ReadOnly = false;
                row[R_TIME] = "";
                db.Columns[R_TIME].ReadOnly = true;

            }


        }
        internal void ClearRowDoneBttn(DataRow row)
        {

            if (!string.Equals((string)row[R_CLEAR], "", StringComparison.Ordinal))
            {
                ClearRowDone(row);

                db.Columns[R_PLAY].ReadOnly = false;
                row[R_PLAY] = "";
                db.Columns[R_PLAY].ReadOnly = true;

                db.Columns[R_CLEAR].ReadOnly = false;
                row[R_CLEAR] = "";
                db.Columns[R_CLEAR].ReadOnly = true;

            }
        }

    }
}
